<?php
namespace LWS\WOOREWARDS\PRO\Ui\Shortcodes;

// don't call the file directly
if( !defined( 'ABSPATH' ) ) exit();

class UserLevel
{
	public static function install()
	{
		$me = new self();
		\add_shortcode('wr_user_level', array($me, 'shortcode'));
	}

	/** Displays the current user level in a leveling loyalty system
	 * [wr_user_level system='poolname' nolevel='No level message']
	 * @param system the loyalty system for which to show the progress bar
	 */
	public function shortcode($atts=array(), $content='')
	{
		$atts = \wp_parse_args($atts, array('system' => '', 'nolevel' => __("No level yet", 'woorewards-pro')));
		$user = \wp_get_current_user();
		if(empty($atts['system']))
			return '';
		if(empty($user))
			return '';
		$content = '';
		$title = $atts['nolevel'];
		/* */
		$pools = \apply_filters('lws_woorewards_get_pools_by_args', false, $atts);
		if ($pools && $pools->count()) {
			$pool = $pools->first();
			if($pool->getOption('type') == \LWS\WOOREWARDS\Core\Pool::T_LEVELLING)
			{
				$userPoints = $pool->getPoints($user->ID);
				foreach ($pool->getUnlockables()->sort()->asArray() as $item)
				{
					if ($item->getCost() <= $userPoints)
					{
						$title = $item->getGroupedTitle('view');
					}
				}
				$content = "<span class='wr-user-level-span'>". $title . "</span>";
			}
		}
		return $content;
	}

}