<?php
namespace LWS\WOOREWARDS\PRO\Ui\Shortcodes;

// don't call the file directly
if( !defined( 'ABSPATH' ) ) exit();

class UserName
{
	public static function install()
	{
		$me = new self();
		\add_shortcode('wr_user_name', array($me, 'shortcode'));
	}

	/** Show user name and title
	 * [wr_user_name title='yes' raw='no']
	 * @param title (bool) default=yes, shows the title if user owns this reward
	 * @param raw (bool) default=no, defines if the name and title are put in divs or not.
	 */
	public function shortcode($atts=array(), $content='')
	{
		$atts = \wp_parse_args($atts, array('title' => 'yes', 'raw' => ''));
		$user = \wp_get_current_user();
		if( $user && $user->ID )
		{
			$content = $user->display_name ? $user->display_name : ($user->user_nicename ? $user->user_nicename : $user->user_login);
			$raw = \LWS\WOOREWARDS\PRO\Conveniences::instance()->argIsTrue($atts['raw']);
			if( \LWS\WOOREWARDS\PRO\Conveniences::instance()->argIsTrue($atts['title']) )
				$content = \LWS\WOOREWARDS\PRO\Core\UserTitle::getDisplayName($user, false, $raw ? '' : 'display');
			if( !$raw )
				$content = sprintf("<span class='wr-name-display'>%s</span>", $content);
		}
		return $content;
	}
}